<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- important parameters -->

<xsl:param name="MODE" select="'Offline'"/>  <!-- offline, classic, select, explore -->
<xsl:param name="OFFSET_X" select="0"/>
<xsl:param name="OFFSET_Y" select="0"/>

<!-- modes -->

<xsl:variable name="mode_offline" select="'Offline'"/>
<xsl:variable name="mode_classic" select="'Classic'"/>
<xsl:variable name="mode_select" select="'Select'"/>
<xsl:variable name="mode_explore" select="'Explore'"/>

<!-- icons -->

<xsl:variable name="TABS11" select="'tabs11.gif'"/>
<xsl:variable name="TABS12" select="'tabs12.gif'"/>
<xsl:variable name="TABS21" select="'tabs21.gif'"/>
<xsl:variable name="TABS22" select="'tabs22.gif'"/>
<xsl:variable name="TABS23" select="'tabs23.gif'"/>
<xsl:variable name="TABS31" select="'tabs31.gif'"/>
<xsl:variable name="TABS32" select="'tabs32.gif'"/>
<xsl:variable name="ROUND_CORNER" select="'cor.gif'"/>
<xsl:variable name="ROUND_CORNERA" select="'cor_a.gif'"/>
<xsl:variable name="ROUND_CORNERB" select="'cor_b.gif'"/>
<xsl:variable name="ROUND_CORNERS" select="'cor_s.gif'"/>
<xsl:variable name="PLUS" select="'plus.gif'"/>
<xsl:variable name="MINUS" select="'minus.gif'"/>
<xsl:variable name="TERMINAL_BACKGROUND" select="'t_back.gif'"/>
<xsl:variable name="TERMINAL_LEFT_CORNER" select="'t_left.gif'"/>
<xsl:variable name="TERMINAL_RIGHT_CORNER" select="'t_right.gif'"/>
<xsl:variable name="L_ARROW" select="'arr_le_a.gif'"/>
<xsl:variable name="INFO" select="'info_a.gif'"/>
<xsl:variable name="ARR_ANI2" select="'tri_do_a.gif'"/>
<xsl:variable name="SIMPLE_ANI" select="'clas_a.gif'"/>
<xsl:variable name="RESET_ANI" select="'reset_a.gif'"/>
<xsl:variable name="ARR_ANI" select="'tri_le_a.gif'"/>
<xsl:variable name="EXPLORE_ANI" select="'expl_a.gif'"/>
<xsl:variable name="SELECT_ANI" select="'select_a.gif'"/>

<!-- colors -->

<xsl:variable name="button_color" select="'#f2e1af'"/>
<xsl:variable name="nonactive_tab_color" select="'#83ACD8'"/>
<xsl:variable name="active_tab_color" select="'#306897'"/>
<xsl:variable name="body_color" select="'#F2F2F2'"/>
<xsl:variable name="button_bar_color" select="'#f1f4f2'"/>
<xsl:variable name="rule_background_color" select="'#CBDBEA'"/>
<xsl:variable name="main_table_border_color" select="'#6289AE'"/>

<!-- tooltips -->

<xsl:variable name="tipp_button_info" select="/Rule/Textsymbols/TBI/@value"/>
<xsl:variable name="tipp_button_back" select="/Rule/Textsymbols/TBB/@value"/>
<xsl:variable name="tipp_button_forward" select="/Rule/Textsymbols/TBF/@value"/>
<xsl:variable name="tipp_button_classic" select="/Rule/Textsymbols/TBC/@value"/>
<xsl:variable name="tipp_button_explore" select="/Rule/Textsymbols/TBE/@value"/>
<xsl:variable name="tipp_button_select" select="/Rule/Textsymbols/TBS/@value"/>
<xsl:variable name="tipp_button_reset" select="/Rule/Textsymbols/TBR/@value"/>
<xsl:variable name="tipp_alt_select" select="/Rule/Textsymbols/TAS/@value"/>
<xsl:variable name="tipp_alt_expand" select="/Rule/Textsymbols/TAE/@value"/>
<xsl:variable name="tipp_terminal_help" select="/Rule/Textsymbols/TTH/@value"/>
<xsl:variable name="tipp_nonterminal_expand" select="/Rule/Textsymbols/TNE/@value"/>
<xsl:variable name="tipp_nonterminal_open" select="/Rule/Textsymbols/TNO/@value"/>
<xsl:variable name="tipp_nonterminal_close" select="/Rule/Textsymbols/TNC/@value"/>
<xsl:variable name="tipp_option_hide" select="/Rule/Textsymbols/TOH/@value"/>
<xsl:variable name="tipp_option_expand" select="/Rule/Textsymbols/TOE/@value"/>
<xsl:variable name="tipp_option_select" select="/Rule/Textsymbols/TOS/@value"/>
<xsl:variable name="tipp_view_change" select="/Rule/Textsymbols/CHV/@value"/>
<xsl:variable name="tipp_view_actual" select="/Rule/Textsymbols/ACV/@value"/>
<xsl:variable name="tipp_iteration_hide" select="/Rule/Textsymbols/TIH/@value"/>
<xsl:variable name="tipp_iteration_show" select="/Rule/Textsymbols/TIS/@value"/>

  <xsl:template match="/">
    <html lang="EN">
      <head>
        <script type="text/javascript">
          function load (link) {   <!-- function for navigation in offline mode -->
            var Ziel = String(link) + ".xml";
            window.location.href = Ziel;
          }
          function resize () { <!-- the initial main container is 20000px width and height; this function resizes it to the right size -->
            var w, h;
            w = document.getElementById("rule").offsetWidth + 50;
            h = document.getElementById("rule").offsetHeight + 50;

            document.getElementById("main").style.setAttribute("width", w, false);
            document.getElementById("main").style.setAttribute("height", h, false);
            window.scrollTo(<xsl:value-of select="$OFFSET_X"/>, <xsl:value-of select="$OFFSET_Y"/>);
          }

          function trigger (sap_event, java_event) { <!-- triggers SAP-Events and passes the actual coordinates of the window -->
            var off_x, off_y;
            if (self.pageYOffset){
              off_x = self.pageXOffset;
              off_y = self.pageYOffset;
          }
          else if (document.documentElement.scrollTop){
          off_x = document.documentElement.scrollLeft;
          off_y = document.documentElement.scrollTop;
          }
          else if (document.body){
          off_x = document.body.scrollLeft;
          off_y = document.body.scrollTop;
          }

          var Ziel = "SAPEVENT:" + String(off_x) + "|" + String(off_y) + "|" + String(sap_event);
          window.location.href = Ziel;

          }

        </script>


        <style type="text/css">

        .link {
          cursor: pointer;
        }

        .help {
          <xsl:if test="$MODE != $mode_offline">
            cursor: help;
          </xsl:if>
        }

        a {
          text-decoration: none;
        }

        img {
          border: 0px;
          padding: 0px;
          margin: 0px;
        }

        body {
          background: <xsl:value-of select="$body_color"/>;
          margin: 10px;
        }

        table#main_table {
          border-collapse: collapse;
          border: 1px solid <xsl:value-of select="$main_table_border_color"/>;
          background: <xsl:value-of select="$rule_background_color"/>;
        }

        td#buttonbar {    <!-- button bar for the navigation buttons -->
          border: 1px solid <xsl:value-of select="$active_tab_color"/>;
          background: <xsl:value-of select="$button_bar_color"/>;
        }

        .nav_button {   <!-- navigation buttons -->
          padding: 1px;
          margin: 1px;
          font-size: 14;
          color: black;
          background: <xsl:value-of select="$button_color"/>;
          border: 1px solid black;
          border-top: 0px;
          border-left: 0px;
        }

        a.nav_button:hover {
          border: 1px solid black;
          border-bottom: 0px;
          border-right: 0px;
        }

        a.nav_button_ani {
          font-size: 7px;
          width: 24px;
          height: 24px;
          z-index: 3;
          float: left;
          background-repeat: no-repeat;
          border-color: <xsl:value-of select="$main_table_border_color"/>;
        }

        a.nav_button_ani:hover {
          background-position: -24px;
        }

        span.seperator {
          font-size: 20px;
          width: 5px;
          height: 24px;
          z-index: 3;
          float: left;
        }

        td#title {    <!-- title area of the rule -->
          border: 2px solid <xsl:value-of select="$active_tab_color"/>;
          background: white;
          padding: 0px;
        }

        span#ruletitle {    <!-- title area of the rule (text) -->
          color: <xsl:value-of select="$active_tab_color"/>;
          font-family: courier new;
          font-weight: bold;
          font-size: 18px;
          z-index: 2;
          background: white;
          margin: 3px 8px;
        }

        .tab {    <!-- tabs for selecting view of a diagram -->
          border-top: 1px solid <xsl:value-of select="$main_table_border_color"/>;
          padding-bottom: 2px;
          font-size: 14;
          color: black;
          background: <xsl:value-of select="$nonactive_tab_color"/>;
        }

        .tab_ecke {   <!-- corner of a tab -->
          margin-bottom: -5px;
        }

        td.main_line {    <!-- main line of the syntax diagram -->
          border-bottom: 1px solid black;
          color: <xsl:value-of select="$rule_background_color"/>;
          padding: 0px;
        }

        td#rule {     <!-- rule area -->
          padding-top: 0px;
          z-index: 1;
        }

        .corner {     <!-- common style for the following corners -->
          position: relative;
          float: left;
          margin: 0px -3px;
          padding: 0px;
        }

        .ol {     <!-- top left corner of an alternative/permutation/optionlist -->
          left: -8px;
          top: -1px;
          filter: FlipH();
        }

        .or {     <!-- top right corner of an alternative/permutation/optionlist -->
          left: 8px;
          top: -1px;
        }

        .ul {     <!-- bottom left corner of an alternative/permutation/optionlist -->
          top: -8px;
          left: -1px;
          filter: FlipH();
        }

        .ula {      <!-- last bottom left corner of an alternative/optionlist -->
          top: -8px;
          filter: FlipH();
        }

        .ulp {      <!-- bottom left corner of an permutation -->
          top: -8px;
          left: 2px;
          filter: FlipH();
        }

        .ur {     <!-- bottom right corner of an alternative/permutation/optionlist -->
          top: -8px;
          left: 1px;
        }

        .iol {    <!-- top left corner of an itaration -->
          left: -8px;
          top: -1px;
        }

        .ior {    <!-- top right corner of an itaration -->
          left: 1px;
          top: -1px;
        }

        table.round_corners {   <!-- round corners table for a terminal/nonterminal/role -->
          float: left;
          border: 0px;
          border-spacing: 0px;
          cell-padding: 0px;
          margin: 0px;
          padding: 0px;
          border-collapse: collapse;
        }

        .terml {    <!-- left corner of a terminal/nonterminal/role -->
          background-image:url(<xsl:value-of select="$TERMINAL_LEFT_CORNER"/>);
          background-repeat:repeat-x;
          height: 18px;
          width: 4px;
          float: left;
          position: relative;
          top: -10px;
          margin-right: -2px;
          padding: 0px;
        }

        .termr {    <!-- right corner of a terminal/nonterminal/role -->
          background-image:url(<xsl:value-of select="$TERMINAL_RIGHT_CORNER"/>);
          background-repeat:repeat-x;
          height: 18px;
          width: 7px;
          float: left;
          position: relative;
          top: -10px;
          margin-left: -2px;
          padding: 0px;
        }

        .text {   <!-- body of terminal/nonterminal/role -->
          border: 0px;
          background-image:url(<xsl:value-of select="$TERMINAL_BACKGROUND"/>);
          background-repeat:repeat-x;
          padding: 1px 0px;
          margin: 0px;
          font-family: courier new;
          font-size: 14;
          position: relative;
          top: -10px;
          float: left;
          z-index: 2;
          font-weight: bold;
        }

        .terminal {
          color: black;
        }

        .role {
          font-weight: normal;
          font-size: 13;
        }

        .nonterminal {
          color: blue;
        }

        .pfeil {    <!-- arrow for iterations/options -->
          font-family: courier new;
          font-weight: bold;
          font-size: 14;
          z-index: 0;
          position: relative;
          top: -9px;
        }

        table.alt_tab {   <!-- common style for alternative/permutation/optionlist table -->
          border-collapse: collapse;
          float: left;
          border: 0;
          margin: 0px 7px 0px 7px;
        }

        table.option {    <!-- space for the option toggle button -->

        }

        .alt {    <!-- common style for alternative/permutation/optionlist elements -->
          white-space: nowrap;
          vertical-align: top;
          z-index: 1;
          border: 0px;
          border-bottom: 1px solid black;
          padding: 0px 0px 3px;
          margin: 0px;
          min-height: 10px;
        }

        td.alt_l {    <!-- left border of an alternative -->
          border-left: 1px solid black;
          margin: 0px;
        }

        td.alt_r {    <!-- right border of an alternative -->
          border-right: 1px solid black;
          margin: 0px -3px;
        }

        td.per_l {    <!-- left border of an permutation -->
          border-left: 3px double black;
        }

        td.per_r {    <!-- right border of an permutation -->
          border-right: 3px double black;
        }

        td.opt_l {    <!-- left border of an optionlist -->
          border-left: 1px dotted black;
        }

        td.opt_r {    <!-- right border of an optionlist -->
          border-right: 1px dotted black;
        }

        tr td.last {
          z-index: 0;
          border: 0px;
          <!-- border-color: <xsl:value-of select="$rule_background_color"/>; -->
          border-bottom: 0px;
        }

        img.opt_min {   <!-- toggle button for optional elements (option open) -->
          z-index: 3;
          float: left;
          position: relative;
          top: -5px;
          left: -25px;
        }

        img.opt_max {   <!-- toggle button for optional elements (option closed) -->
          z-index: 3;
          float: left;
          position: relative;
          top: -5px;
          left: 3px;
        }

        img.nonter_min {    <!-- toggle button for nonterminals (nonterminal open) -->
          z-index: 3;
          float: left;
          position: relative;
          top: -5px;
          left: -8px;
        }

        img.nonter_max {    <!-- toggle button for nonterminals (nonterminal closed) -->
          border: 0;
          margin-left: 2px;
        }

        a.arr_left {      <!-- toggle button for alternatives -->
          font-size: 7px;
          width: 11px;
          height: 18px;
          z-index: 3;
          float: left;
          position: relative;
          top: -10px;
          left: -2px;
          background-image:url(<xsl:value-of select="$ARR_ANI"/>);
          background-repeat: no-repeat;
        }

        a.arr_left:hover
        {
          background-position: -11px;
        }
        a.arr_down {      <!-- toggle button for alternatives -->
          font-size: 7px;
          width: 18px;
          height: 11px;
          z-index: 3;
          float: left;
          position: relative;
          top: -4px;
          left: -2px;
          background-image:url(<xsl:value-of select="$ARR_ANI2"/>);
          background-repeat: no-repeat;
        }

        a.arr_up {      <!-- toggle button for alternatives -->
          font-size: 7px;
          width: 18px;
          height: 11px;
          z-index: 3;
          float: left;
          position: relative;
          top: -6px;
          left: -2px;
          background-image:url(<xsl:value-of select="$ARR_ANI2"/>);
          background-repeat: no-repeat;
          filter: FlipV();
        }

        a.arr_down:hover
        {
          background-position: 0px -11px;
        }

        a.arr_up:hover
        {
          background-position: 0px -11px;
        }

        img.alt_arr {     <!-- toggle button for alternatives -->
          z-index: 3;
          float: left;
          position: relative;
          top: -1px;
          left: -2px;
          margin: -2px;
        }

        div.nonterminal_open {
          display: inline-block;
          float: left;
          border: 1px solid <xsl:value-of select="$nonactive_tab_color"/>;
          margin-right: 4px;
          margin-left: 4px;
          padding-top: 2px;
          position: relative;
          top: -12px;
          z-index: 2;
        }

        div.nonterminal_open2 {
          display: inline-block;
          float: left;
          position: relative;
          top: 9px;
        }
        </style>
        <title>Syntax diagram</title>
      </head>
      <body onload="resize()">
        <div id="main" style="display: inline-block; height: 200000px; width: 20000px;">
          <xsl:apply-templates />
        </div>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="Textsymbols">
  </xsl:template>

  <xsl:template match="Rule">
    <xsl:variable name="name_without_underscores" select="translate(@name, '_', ' ')" />
    <table id="main_table">
      <xsl:if test="$MODE != $mode_offline">
      <tr>
        <td id="buttonbar">
          <a href="javascript:trigger('Navigate|Back', event)" class="link nav_button_ani" title="{$tipp_button_back}" style="background-image:url({$L_ARROW})"/>
          <a href="javascript:trigger('Navigate|Forward', event)" class="link nav_button_ani" title="{$tipp_button_forward}" style="filter: FlipH(); background-image:url({$L_ARROW})"/>
          <a href="javascript:trigger('Navigate|Reset', event)" class="link nav_button_ani" title="{$tipp_button_reset}" style="background-image:url({$RESET_ANI})"/>
          <span class="seperator">|</span>
          <xsl:choose>
            <xsl:when test="$MODE = $mode_classic">
              <a href="javascript:trigger('Modus|{$mode_classic}', event)" class="link nav_button_ani" title="{$tipp_button_classic}" style="border: 1px solid; background-image:url({$SIMPLE_ANI})"/>
            </xsl:when>
            <xsl:otherwise>
              <a href="javascript:trigger('Modus|{$mode_classic}', event)" class="link nav_button_ani" title="{$tipp_button_classic}" style="background-image:url({$SIMPLE_ANI})"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$MODE = $mode_explore">
              <a href="javascript:trigger('Modus|{$mode_explore}', event)" class="link nav_button_ani" title="{$tipp_button_explore}" style="border: 1px solid; background-image:url({$EXPLORE_ANI})"/>
            </xsl:when>
            <xsl:otherwise>
              <a href="javascript:trigger('Modus|{$mode_explore}', event)" class="link nav_button_ani" title="{$tipp_button_explore}" style="background-image:url({$EXPLORE_ANI})"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="$MODE = $mode_select">
              <a href="javascript:trigger('Modus|{$mode_select}', event)" class="link nav_button_ani" title="{$tipp_button_select}" style="border: 1px solid; background-image:url({$SELECT_ANI})"/>
            </xsl:when>
            <xsl:otherwise>
              <a href="javascript:trigger('Modus|{$mode_select}', event)" class="link nav_button_ani" title="{$tipp_button_select}" style="background-image:url({$SELECT_ANI})"/>
            </xsl:otherwise>
          </xsl:choose>
          <span class="seperator">|</span>
          <a href="javascript:trigger('help_syntax_diagrams', event)" class="link nav_button_ani" title="{$tipp_button_info}" style="background-image:url({$INFO})"/>
        </td>
      </tr>
      </xsl:if>
      <tr>
        <td id="title">
          <span id="ruletitle">
            <xsl:value-of select="$name_without_underscores" />
          </span>
          <xsl:if test="$MODE != $mode_offline">
            <xsl:apply-templates mode="view_tabs" />
          </xsl:if>
        </td>
      </tr>
      <tr>
        <td class="main_line">-</td>
      </tr>
      <tr>
        <td id="rule">
          <xsl:apply-templates />
        </td>
      </tr>
    </table>
  </xsl:template>


  <xsl:template mode="view_tabs" match="View">
    <xsl:variable name="pos" select="position() - 1" />
    <xsl:choose>
      <xsl:when test="position() = 1">
        <xsl:choose>
          <xsl:when test="/Rule/@select = @type">
            <img class="tab_ecke" src="{$TABS12}" />
          </xsl:when>
          <xsl:otherwise>
            <img class="tab_ecke" src="{$TABS11}" />
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="/Rule/@select = @type">
            <img class="tab_ecke" src="{$TABS23}" />
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when
                test="/Rule/@select = /Rule/View[$pos]/@type">
                <img class="tab_ecke" src="{$TABS21}" />
              </xsl:when>
              <xsl:otherwise>
                <img class="tab_ecke" src="{$TABS22}" />
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="/Rule/@select = @type">
        <a class="tab" title="{$tipp_view_actual}"
          Style="background: {$active_tab_color}; color: white;">
          <xsl:value-of select="@type" />
        </a>
      </xsl:when>
      <xsl:otherwise>
        <a href="javascript:trigger('Change|{@type}', event)"
          class="tab" title="{$tipp_view_change}"
          Style="background: {$nonactive_tab_color}; border-color: {$nonactive_tab_color};">
          <xsl:value-of select="@type" />
        </a>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="position() = count(../View)">
        <xsl:choose>
          <xsl:when test="/Rule/@select = @type">
            <img class="tab_ecke" src="{$TABS32}" />
          </xsl:when>
          <xsl:otherwise>
            <img class="tab_ecke" src="{$TABS31}" />
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="View">
    <xsl:choose>
      <xsl:when test="/Rule/@select = @type">
        <xsl:apply-templates />
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Desctab">
    <table border="1px">
      <xsl:apply-templates />
    </table>
  </xsl:template>

  <xsl:template match="Desc">
    <tr>
      <td align="center" valign="middle">
        <table>
          <tr>
            <td class="main_line">-</td>
          </tr>
          <tr style="position:relative; top: -3px; left: 1px;">
            <td><xsl:apply-templates /></td>
           </tr>
        </table>
      </td>
      <td style="width: 600px;">
        <xsl:value-of select="./Text" />
      </td>
    </tr>
  </xsl:template>

  <xsl:template match="Text"></xsl:template>

  <xsl:template match="Option">
    <xsl:choose>
      <xsl:when test="@toggle = '0'">
        <table class="alt_tab option">
          <tr>
            <td valign="top" class="alt alt_l">
              <img class="corner ol" src="{$ROUND_CORNERA}" />
            </td>
            <td align="center" class="alt">
              <xsl:if test="$MODE = $mode_explore or $MODE = $mode_select">
                <a class="arr_left" href="javascript:trigger('Toggle|{@id}|1', event)" title="{$tipp_option_hide}" />
              </xsl:if>
              <span class="pfeil">&gt;</span>
            </td>
            <td valign="top" class="alt alt_r">
              <img class="corner or" src="{$ROUND_CORNERA}" />
            </td>
          </tr>
          <xsl:choose>
            <xsl:when test="count(./*) = 1 and count(./Alternative) = 1 and ./Alternative[1]/@toggle = 0">
              <xsl:apply-templates />
            </xsl:when>
            <xsl:otherwise>
              <tr>
                <td align="right" valign="top" class="alt alt_l last">
                  <img class="corner ula" src="{$ROUND_CORNER}" />
                </td>
                <td class="alt last">
                  <xsl:if test="$MODE = $mode_explore or $MODE = $mode_select">
                    <a class="arr_left" href="javascript:trigger('Toggle|{@id}|2', event)" title="{$tipp_option_select}" />
                  </xsl:if>
                  <xsl:apply-templates />
                </td>
                <td align="left" valign="top" class="alt alt_r last">
                  <img class="corner ur" src="{$ROUND_CORNER}" />
                </td>
              </tr>
            </xsl:otherwise>
          </xsl:choose>
        </table>
      </xsl:when>
      <xsl:when test="@toggle = '1'">
        <xsl:if test="$MODE = $mode_explore">
          <a class="arr_up" href="javascript:trigger('Toggle|{@id}|0', event)" title="{$tipp_option_expand}" />
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:if test="$MODE = $mode_explore and count(./Alternative) != 1">
          <a class="arr_up" href="javascript:trigger('Toggle|{@id}|0', event)" title="{$tipp_option_expand}" />
        </xsl:if>
        <xsl:apply-templates />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Iteration">
    <xsl:choose>
    <xsl:when test="@toggle = '0'">
    <table class="alt_tab">
      <tr>
        <td valign="top" class="alt alt_l">
          <div style="display: inline-block; width: 6px; height: 15px; overflow: visible;">
            <img class="corner iol" src="{$ROUND_CORNERS}"/>
          </div>
        </td>
        <td align="center" class="alt">
          <span class="pfeil">&lt;</span>
        </td>
        <td valign="top" class="alt alt_r">
          <div style="display: inline-block; border-right: 1px solid black; width: 6px; height: 15px; overflow: visible;">
            <img class="corner ior" src="{$ROUND_CORNERS}" />
          </div>
        </td>
      </tr>
      <xsl:choose>
        <xsl:when test="count(*) = 1 and count(Alternative) = 1 and ./Alternative[1]/@toggle = 0">
          <xsl:apply-templates />
        </xsl:when>
        <xsl:otherwise>
          <tr>
            <td valign="top" class="alt alt_l last">
              <img class="corner ula" src="{$ROUND_CORNER}" />
            </td>
            <td class="alt last">
              <xsl:if test="$MODE = $mode_explore or $MODE = $mode_select">
                <a class="arr_left" href="javascript:trigger('Toggle|{@id}|1', event)" title="{$tipp_iteration_hide}" />
              </xsl:if>
              <xsl:apply-templates />
            </td>
            <td valign="top" class="alt alt_r last">
              <img class="corner ur" src="{$ROUND_CORNER}" />
            </td>
          </tr>
        </xsl:otherwise>
      </xsl:choose>
    </table>
    </xsl:when>
    <xsl:otherwise>
      <xsl:if test="$MODE = $mode_explore">
        <a class="arr_up" href="javascript:trigger('Toggle|{@id}|0', event)" title="{$tipp_iteration_show}" />
      </xsl:if>
      <xsl:apply-templates />
    </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Sequence">
    <xsl:apply-templates />
  </xsl:template>

  <xsl:template match="Alternative">
    <xsl:choose>
      <xsl:when test="count(../*) = 1 and name(..) = 'Option'">
        <xsl:apply-templates />
      </xsl:when>
      <xsl:when test="count(../*) = 1 and name(..) = 'Iteration'">
        <xsl:apply-templates />
      </xsl:when>
      <xsl:when test="@toggle != 0">
        <xsl:apply-templates />
      </xsl:when>
      <xsl:otherwise>
        <table class="alt_tab">
          <xsl:apply-templates />
        </table>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Alt">
    <xsl:choose>
      <xsl:when test="../@toggle = 0">
        <xsl:choose>
          <xsl:when test="position() != last()">
            <tr>
              <td align="left" valign="top" class="alt alt_l">
                <xsl:choose>
                  <xsl:when test="position() = 1 and name(../..) != 'Option' and name(../..) != 'Iteration'">
                    <img class="corner ol" src="{$ROUND_CORNERA}" />
                  </xsl:when>
                  <xsl:otherwise>
                    <img class="corner ul" src="{$ROUND_CORNERB}" />
                  </xsl:otherwise>
                </xsl:choose>
              </td>
              <td class="alt">
                <xsl:if test="$MODE = $mode_select or $MODE = $mode_explore">
                  <a class="arr_left" href="javascript:trigger('Toggle|{../@id}|{position()}', event)" title="{$tipp_alt_select}" />
                </xsl:if>
                <xsl:apply-templates />
              </td>
              <td align="left" valign="top" class="alt alt_r">
                <xsl:choose>
                  <xsl:when test="position() = 1  and name(../..) != 'Option' and name(../..) != 'Iteration'">
                    <img class="corner or" src="{$ROUND_CORNERA}" />
                  </xsl:when>
                  <xsl:otherwise>
                    <img class="corner ur" src="{$ROUND_CORNERB}" />
                  </xsl:otherwise>
                </xsl:choose>
              </td>
            </tr>
          </xsl:when>
          <xsl:otherwise>
            <tr>
              <td align="left" valign="top" class="alt alt_l last">
                <img class="corner ula" src="{$ROUND_CORNER}" />
              </td>
              <td class="alt last">
                <xsl:if test="$MODE = $mode_select or $MODE = $mode_explore">
                  <a class="arr_left" href="javascript:trigger('Toggle|{../@id}|{position()}', event)" title="{$tipp_alt_select}" />
                </xsl:if>
                <xsl:apply-templates />
              </td>
              <td align="left" valign="top" class="alt alt_r last">
                <img class="corner ur" src="{$ROUND_CORNER}" />
              </td>
            </tr>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="../@toggle = position()">
        <xsl:if test="$MODE = $mode_explore">
          <a class="arr_down" href="javascript:trigger('Toggle|{../@id}|0', event)" title="{$tipp_alt_expand}" />
        </xsl:if>
        <xsl:apply-templates />
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Optionlist">
    <table class="alt_tab">
      <xsl:apply-templates />
    </table>
  </xsl:template>

  <xsl:template match="Opt">
    <xsl:choose>
      <xsl:when test="position() != last()">
        <tr>
          <td valign="top" class="alt opt_l">
          <xsl:choose>
            <xsl:when test="position() = 1">
                <img class="corner ol" src="{$ROUND_CORNERA}" />
            </xsl:when>
            <xsl:otherwise>
                <img class="corner ul" src="{$ROUND_CORNERB}" />
            </xsl:otherwise>
          </xsl:choose>
          </td>
          <td class="alt">
            <xsl:apply-templates />
          </td>
          <td valign="top" class="alt opt_r">
          <xsl:choose>
            <xsl:when test="position() = 1">
                <img class="corner or" src="{$ROUND_CORNERA}" />
            </xsl:when>
            <xsl:otherwise>
                <img class="corner ur" src="{$ROUND_CORNERB}" />
            </xsl:otherwise>
          </xsl:choose>
          </td>
        </tr>
      </xsl:when>
      <xsl:otherwise>
        <tr>
          <td valign="top" class="alt opt_l last">
            <img class="corner ula" src="{$ROUND_CORNER}" />
          </td>
          <td class="alt last">
            <xsl:apply-templates />
          </td>
          <td valign="top" class="alt opt_r last">
            <img class="corner ur" src="{$ROUND_CORNER}" />
          </td>
        </tr>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Permutation">
    <xsl:choose>
      <xsl:when test="count(Per) > 1">
        <table class="alt_tab">
          <xsl:apply-templates />
        </table>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Per">
    <xsl:choose>
    <xsl:when test="$MODE = $mode_explore or $MODE = $mode_offline or count(../Per) > 1">
    <xsl:choose>
      <xsl:when test="position() != last()">
        <tr>
          <td valign="top" class="alt per_l">
          <xsl:choose>
            <xsl:when test="position() = 1">
                <img class="corner ol" src="{$ROUND_CORNERA}" />
            </xsl:when>
            <xsl:otherwise>
                <img class="corner ul" src="{$ROUND_CORNERB}" />
            </xsl:otherwise>
          </xsl:choose>
          </td>
          <td class="alt">
            <xsl:apply-templates />
          </td>
          <td valign="top" class="alt per_r">
          <xsl:choose>
            <xsl:when test="position() = 1">
                <img class="corner or" src="{$ROUND_CORNERA}" />
            </xsl:when>
            <xsl:otherwise>
                <img class="corner ur" src="{$ROUND_CORNERB}" />
            </xsl:otherwise>
          </xsl:choose>
          </td>
        </tr>
      </xsl:when>
      <xsl:otherwise>
        <tr>
          <td valign="top" class="alt per_l last">
            <img class="corner ulp" src="{$ROUND_CORNER}" />
          </td>
          <td class="alt last">
            <xsl:apply-templates />
          </td>
          <td valign="top" class="alt per_r last">
            <img class="corner ur" src="{$ROUND_CORNER}" />
          </td>
        </tr>
      </xsl:otherwise>
    </xsl:choose>
    </xsl:when>
    <xsl:otherwise>
      <xsl:apply-templates />
    </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Terminal">
    <xsl:variable name="link" select="." />
    <table class="round_corners">
      <tr>
        <td class="terml" />
        <xsl:choose>
          <xsl:when test="$MODE != $mode_offline">
            <td class="text terminal help" onclick="trigger('Call|{@id}', event)" title="{$tipp_terminal_help}">
              <nobr><xsl:value-of select="$link" /></nobr>
            </td>
          </xsl:when>
          <xsl:otherwise>
            <td class="text terminal help">
              <nobr><xsl:value-of select="$link" /></nobr>
            </td>
          </xsl:otherwise>
        </xsl:choose>
        <td class="termr" />
      </tr>
    </table>
  </xsl:template>

  <xsl:template match="Nonterminal">
    <xsl:variable name="link" select="@name" />
    <xsl:variable name="show" select="translate(@name, '_', ' ')" />
    <xsl:choose>
      <xsl:when test="@toggle = '0'">
        <table class="round_corners">
          <tr>
            <td class="terml" />
            <xsl:choose>
              <xsl:when test="$MODE != $mode_offline">
                <td class="text nonterminal link" onclick="trigger('Load|{$link}', event)" title="{$tipp_nonterminal_open}">
                  <nobr>
                    <xsl:value-of select="$show" />
                  </nobr>
                </td>
              </xsl:when>
              <xsl:otherwise>
                <td class="text nonterminal link" onclick="load('{$link}')" title="{$tipp_nonterminal_open}">
                  <nobr>
                    <xsl:value-of select="$show" />
                  </nobr>
                </td>
              </xsl:otherwise>
            </xsl:choose>
            <xsl:if test="$MODE = $mode_explore or $MODE = $mode_select">
              <td class="text link" onclick="trigger('Expand|{@id}|{$link}', event)">
                <img class="nonter_max" src="{$PLUS}" title="{$tipp_nonterminal_expand}"/>
              </td>
            </xsl:if>
            <td class="termr" />
          </tr>
        </table>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$MODE = $mode_explore">
            <div class="nonterminal_open">
              <div class="nonterminal_open2">
                <a href="javascript:trigger('Toggle|{@id}|0', event)">
                  <img class="nonter_min" src="{$MINUS}" />
                </a>
                <xsl:apply-templates />
              </div>
            </div>
          </xsl:when>
          <xsl:otherwise>
            <xsl:apply-templates />
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="Role">
    <xsl:variable name="role_name" select="."/>
    <table class="round_corners">
      <tr>
        <td class="terml" />
        <td class="text role">
          <xsl:if test="count(/Rule/Textsymbols/Tipp[@name = $role_name]) = 1">
            <xsl:attribute name="title">
              <xsl:value-of select="/Rule/Textsymbols/Tipp[@name = $role_name]/@text" />
            </xsl:attribute>
          </xsl:if>
          <xsl:value-of select="." />
        </td>
        <td class="termr" />
      </tr>
    </table>
  </xsl:template>

  <xsl:template match="Context"></xsl:template>
  <xsl:template match="Attribute"></xsl:template>


</xsl:stylesheet>
